///////////////////////////////////////////////////////////////////////////////
// Diese Anwendung ffnet eine vorher angegebene C-Skript Datei und bringt sie
// vom Syntax her auf den neusten Stand. Ausserdem werden alle Includes berck-
// sichtigt.
//
// MADE BY: ALEXANDER ESSLINGER

//Funktion-Prototypen:
//User-Interface Funktionen
function handleUI();
function handleFileStats();
function buttonConvert();
function buttonExit();
function buttonInput();
function togglePreview();
function toggleBold();
function errorMsg(eNum);
//Haupt-Programm Funktionen
function file_operation();
	function preScan(qFile);
	function preWrite(tFile);
function convertQName2TName(tStr,qName);
function checkForComments(cStat);
function getNextCommand(qFile,tFile);
function getASC(str,offset);
function findASC(str,endMark);
	define fLetter = 1;
	define fNumber = 2;
	define fSpace = 4;
	define fComma = 8;
	define fSemicolon = 16;
	define fUnderline = 32;
	define fBracket = 64; //Runde Klammern
	define fWBracket = 128; //Geschweifte Klammern
	define fPBracket = 256; //Spitze Klammern
	define fPoint = 512;
	define fQuotem = 1024; //Anfhrungszeichen
	define fOperater = 2048; //Rechenzeichen
function getValue(tStr,str,endMark); //"endMark" benutzt die Filter von "findASC"
function checkCommand();
	function includeFILE();
	function updateACCEL();
	function updateSET();
	function updateSKILL();
	function updateCALL();
	function updateWAIT();
	function updateWAITT();
	function updateTOANGLE();
	function updateVECROTATE();
	function updateNORMALIZE();
	function updateTOSKILL();
	function updateTOSTRING();
	function updateSETSTRING();
	function updateADDSTRING();
	function updateSTRICMP();
	function updateEND();

define tab = 9;
define enter = 13;
define space = 32;
define komma = 44;
define semikolon = 59;

//Pfade
path "bmps";

//Engine-Variablen
var video_screen = 2;

//Variablen
var getFileStats;
var writeFile; //Nur bei "1" wird in Dateien geschrieben
var foundAccel; //Falls "1", wird eine "accel"-funktion definiert
	//Verschiedene Errors
	define err01 = 1; //ERROR: Quell-Datei kann nicht geffnet werden.
	define err02 = 2; //ERROR: Ziel-Datei kann nicht erstellt werden.
	define err03 = 3; //ERROR: Endless-loop in findASC.
	define err04 = 4; //ERROR: Endless-loop in getValue.
	define err05 = 5; //Erfolgreich beendet
var char;
var lChars[10]; //Speichert die letzten 10 Chars, damit Schlsselwrter berprft werden knnen
var prototypesDone; //Ob die Prototypes schon in die Datei geschrieben wurden. Immer fr die entsprechende Datei

//Options
var showPreview = 1;
var boldKeywords = 0;

//Stats-Variablen
var sOldCommands;
var sIncludedFiles;
var sAccel;
var sActions;

//Strings
string inputString[30];
	string tmpIString[30];
string logString[1024];
string fileStats[512];
string button1Str = "CONVERT";
string button2Str = "EXIT";
string checkBox1Str = "Show File-Details";
string checkBox2Str = "Bold Keywords";

string charStr; //Ein temporrer String fr ein Zeichen
string qStr[32]; //Name der Quell-Datei
string tStr[32]; //Name der Ziel-Datei
string tmpStr[5120]; //Ein temporrer String
string tmpCStr[5120]; //Speichert den "commandStr"
string commandStr[5120]; //Enthlt immer den Befehl mit dem gerade gearbeitet wird
string fixedCommandStr[5120]; //Die upgedatete Version des "commandStr"
string preScanTmp[10240]; //Je mehr Actionen die Skript-Datei enthlt desto lnger muss dieser String sein

string aStr[1024]; //Speichert ergebnisse aus Befehlen
string bStr[1024];
string cStr[1024];
string dStr[1024];

//Bilder
bmap ui_cg = <ui.bmp>;
bmap bg_cg = <bg.bmp>;
bmap buttonA = <buttona.bmp>;
bmap buttonB = <buttonb.bmp>;
bmap checkBoxA = <chkbox1.bmp>;
bmap checkBoxB = <chkbox2.bmp>;
bmap checkBoxC = <chkbox3.bmp>;
bmap checkBoxD = <chkbox4.bmp>;
bmap mouse_cg = <mouse.bmp>;
bmap mouseS_cg = <mouses.tga>;
bmap input_cg = <inputf.bmp>;

//Schriften
font dFont = <msgfont.tga>,12,16;

//Panel
panel bgPanel {bmap = bg_cg; layer = 6; flags = visible,refresh,d3d;}
panel uiPanel {bmap = ui_cg; layer = 10; flags = visible,refresh,d3d,overlay; 
	button = 519,24,buttonB,buttonA,buttonA,buttonConvert,null,null; 
	button = 519,59,buttonB,buttonA,buttonA,buttonExit,null,null;
	button = 22,46,input_cg,input_cg,input_cg,buttonInput,null,null;} 
panel mouseSPanel {bmap = mouses_cg; layer = 14; flags = visible,refresh,d3d;}
panel previewCheckboxA {layer = 12; flags = refresh,d3d; button = 22,200,checkBoxA,checkBoxA,checkBoxB,togglePreview,null,null;}
panel previewCheckboxB {layer = 12; flags = refresh,d3d; button = 22,200,checkBoxC,checkBoxC,checkBoxD,togglePreview,null,null;}
panel boldCheckboxA {layer = 12; flags = refresh,d3d; button = 22,220,checkBoxA,checkBoxA,checkBoxB,toggleBold,null,null;}
panel boldCheckboxB {layer = 12; flags = refresh,d3d; button = 22,220,checkBoxC,checkBoxC,checkBoxD,toggleBold,null,null;}

//Texte
text inputText {pos_x = 24; pos_y = 46; layer = 8; strings = 1; string = inputString; font = dFont; flags = visible;}
text logText {pos_x = 12; pos_y = 240; layer = 8; strings = 1; string = logString; font = dFont; flags = visible,d3d;}
text statsText {pos_x = 16; pos_y = 94; layer = 12; strings = 1; string = fileStats; font = dFont; flags = visible,d3d;}
text button1Text {pos_x = 574; pos_y = 38; layer = 12; strings = 1; string = button1Str; font = dFont; flags = visible,d3d,center_x,center_y;}
text button2Text {pos_x = 574; pos_y = 73; layer = 12; strings = 1; string = button2Str; font = dFont; flags = visible,d3d,center_x,center_y;}
text checkBox1Text {pos_x = 40; pos_y = 204; layer = 12; strings = 1; string = checkBox1Str; font = dFont; flags = visible,d3d,center_y;}
text checkBox2Text {pos_x = 40; pos_y = 224; layer = 12; strings = 1; string = checkBox2Str; font = dFont; flags = visible,d3d,center_y;}

///////////////////////////////////////
// Die Main Funktion, wird hier aussnahmsweise auch noch als Auswertungs-
// Funktion der Fehler bzw. Ergebnisse genutzt.
function main()
{	
	handleUI();
	handleFileStats();
}


///////////////////////////////////////
// Zeigt die Eigenschaften der Datei
function handleFileStats()
{
	var handle;
	var gotStats;
	
	while(1)
	{
				
		if(str_cmpi(inputString,tmpIString) == 0) {gotStats = 0;}
		
		if(gotStats == 0)
		{
			handle = file_open_game(inputString);
			if(handle)
			{
				sOldCommands = 0;
				sIncludedFiles = 0;
				sAccel = 0;
				sActions = 0;
				
				if(showPreview)
				{
					str_cpy(qStr,inputString);
					writeFile = 0;
					file_operation();
					
					gotStats = 1;
				}
				
				str_cpy(fileStats,"STATS OF "); str_cat(fileStats,inputString); str_cat(fileStats,":\n");
				str_cat(fileStats,"    OLD COMMANDS:   "); if(showPreview) {str_for_num(tmpStr,sOldCommands); str_cat(fileStats,tmpStr); str_cat(fileStats,"\n");} else {str_cat(fileStats,"---\n");}
				str_cat(fileStats,"    INCLUDED FILES: "); if(showPreview) {str_for_num(tmpStr,sIncludedFiles); str_cat(fileStats,tmpStr); str_cat(fileStats,"\n");} else {str_cat(fileStats,"---\n");}
				str_cat(fileStats,"    ACCEL FOUND:    "); if(showPreview) {str_for_num(tmpStr,sAccel); str_cat(fileStats,tmpStr); str_cat(fileStats,"\n");} else {str_cat(fileStats,"---\n");}
				str_cat(fileStats,"    ACTIONS:        "); if(showPreview) {str_for_num(tmpStr,sActions); str_cat(fileStats,tmpStr); str_cat(fileStats,"\n");} else {str_cat(fileStats,"---\n");}				
			}
			else
			{
				str_cpy(fileStats,"STATS OF ---: \n");
				str_cat(fileStats,"    OLD COMMANDS:   ---\n");
				str_cat(fileStats,"    INCLUDED FILES: ---\n");
				str_cat(fileStats,"    ACCEL FOUND:    ---\n");
				str_cat(fileStats,"    ACTIONS:        ---\n");
				
				gotStats = 1;
			}
		}

		str_cpy(tmpIString,inputString);
		
		wait(4);
	}
}


///////////////////////////////////////
// Verwaltet die Benutzung der Maus und das Aussehen aller anderen Oberflchen.
function handleUI()
{
	mouse_map = mouse_cg;
	mouse_mode = 2;
	
	while(1)
	{
		//Maus
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		mouseSPanel.pos_x = pointer.x+1;
		mouseSPanel.pos_y = pointer.y+1;
		
		//Checkboxen
		if(showPreview) {previewCheckboxA.visible = off; previewCheckboxB.visible = on;}
			else {previewCheckboxA.visible = on; previewCheckboxB.visible = off;}
		if(boldKeywords) {boldCheckboxA.visible = off; boldCheckboxB.visible = on;}
			else {boldCheckboxA.visible = on; boldCheckboxB.visible = off;}
		
		wait(1);
	}
}


///////////////////////////////////////
// Startet die Convertierung
function buttonConvert()
{	
	str_cpy(qStr,inputString);
	convertQName2TName(tStr,qStr);
	
	str_cpy(logString,"");
	
	writeFile = 1;
	if(file_operation() == -1) {errorMsg(err05);} //Erfolgreich beendet
}


///////////////////////////////////////
// Beendet das Programm
function buttonExit()
{
	exit;
}


///////////////////////////////////////
// Handhabt den Input in das entsprechende Feld.
function buttonInput()
{
	inkey(inputString);
}


///////////////////////////////////////
// Diese Funktion setzt showPreview entweder auf 1 oder 0, entsprechend zu
// seinem vorherigen Wert.
function togglePreview()
{
	if(showPreview) {showPreview = 0;} else {showPreview = 1;}
}


///////////////////////////////////////
// Diese Funktion setzt boldKeywords entweder auf 1 oder 0, entsprechend zu
// seinem vorherigen Wert.
function toggleBold()
{
	if(boldKeywords) {boldKeywords = 0;} else {boldKeywords = 1;}
}


///////////////////////////////////////
// Schreibt die entsprechende Fehlermeldung in das dafr vorgesehene Fenster.
function errorMsg(eNum)
{
	if(str_len(logString)) {str_cat(logString,"\n");}
	if(eNum == err01) {str_cat(logString,"ERROR --- CANNOT OPEN "); str_cat(logString,qStr); str_cat(logString,".");}
	if(eNum == err02) {str_cat(logString,"ERROR --- CANNOT OPEN "); str_cat(logString,tStr); str_cat(logString,".");}
	if(eNum == err03) {str_cat(logString,"ERROR --- ENDLESS-LOOP IN FINDASC().");}
	if(eNum == err04) {str_cat(logString,"ERROR --- ENDLESS-LOOP IN GETVALUE().");}
	if(eNum == err05) {str_cat(logString,"UPDATE SUCCESFUL");}
}


///////////////////////////////////////
// Die eigentliche Haupfunktion. Hier werden die Dateien geffnet und alle
// weiteren Funktion aufgerufen.
function file_operation()
{	
	var qFile; //Quell-Datei
	var tFile; //Ziel-Datei
	var mustIncludeFile; 
	var realScan;
//	var foundComment;
//	var foundAction;
	
//	if(str_cmpi(qStr,tStr) == 1) {return(err01);} //ERROR: Ziel- und Quell-Datei sind gleich
	
	qFile = file_open_game(qStr);
		if(qFile == 0) {if(writeFile) {errorMsg(err01);} return;} //ERROR: Quell-Datei kann nicht geffnet werden.
	
	if(writeFile)
	{
		tFile = file_open_write(tStr);
			if(tFile == 0) {errorMsg(err02); return;} //ERROR: Ziel-Datei kann nicht geffnet werden
	}
	
	while(1)
	{
		if(realScan == 0) //Suche nach allen Aktionen
		{
			preScan(qFile);
			file_close(qFile); qFile = file_open_read(qStr); //Setze die Leseposition wieder an den Anfang der Datei
			prototypesDone = 0; //Das die Prototypes auch in die Datei geschrieben werden
			realScan = 1;
		}
		else
		{
			//Lies den nchsten Befehl aus
			if(getNextCommand(qFile,tFile) == -1) {file_close(qFile); if(writeFile) {file_close(tFile);} return(-1);} //Ende der Datei erreicht?
			
			//War der Befehl ein Include?
			if(checkCommand() == 1) {mustIncludeFile = 1;} //Include-Datei ffnen, qFile und tFile wurden schon in "includeFILE()" gesetzt
			
			//Schreibe den Befehl in die tFile
			if(writeFile) {file_str_write(tFile,fixedCommandStr);}
			
			//berprfe auch die include Datei
			if(mustIncludeFile == 1) {mustIncludeFile = 0; file_operation();}
		}
//		wait(1);
	}
}


///////////////////////////////////////
// Diese Funktion durchsucht die aktuelle Skript-Datei nach allen Funktionen
// und speichert diese im "preScanTmp"-String
function preScan(qFile)
{
	var i;
	var foundComment;
	var foundAction;
	
	str_cpy(preScanTmp,"");
	//Leere das lChars-Array
	lChars[0] = 0; lChars[1] = 0; lChars[2] = 0; lChars[3] = 0; lChars[4] = 0; lChars[5] = 0; lChars[6] = 0; lChars[7] = 0; lChars[8] = 0; lChars[9] = 0;
	char = 0;
	while(char != -1)
	{
		char = file_asc_read(qFile);
		//Speichere die letzten 8 Zeichen und lese ein neues ein
		lChars[0] = lChars[1]; lChars[1] = lChars[2]; lChars[2] = lChars[3]; lChars[3] = lChars[4]; lChars[4] = lChars[5];
			lChars[5] = lChars[6]; lChars[6] = lChars[7]; lChars[7] = lChars[8]; lChars[8] = lChars[9]; lChars[9] = char;
		
		foundComment = checkForComments(foundComment);
		
		if(foundComment == 0)
		{
			//Accel gefunden?
			if((lChars[3] != 95)                            //!"_"
				&& (lChars[4] ==  65 || lChars[4] ==  97) //"A" || "a"
				&& (lChars[5] ==  67 || lChars[5] ==  99) //"C" || "c"
				&& (lChars[6] ==  67 || lChars[6] ==  99) //"C" || "c"
				&& (lChars[7] ==  69 || lChars[7] == 101) //"E" || "e"
				&& (lChars[8] ==  76 || lChars[8] == 108) //"L" || "l
				&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab))//" "
					{foundAccel = 1; sAccel += 1;}
			
			//Eine Aktion gefunden?			
			if((lChars[2] != 95)                            //!"_"
				&& (lChars[3] ==  65 || lChars[3] ==  97) //"A" || "a"
				&& (lChars[4] ==  67 || lChars[4] ==  99) //"C" || "c"
				&& (lChars[5] ==  84 || lChars[5] == 116) //"T" || "t"
				&& (lChars[6] ==  73 || lChars[6] == 105) //"I" || "i"
				&& (lChars[7] ==  79 || lChars[7] == 111) //"O" || "o
				&& (lChars[8] ==  78 || lChars[8] == 110) //"N" || "n"
				&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab))//" "
					{foundAction = 1; str_cpy(tmpCStr,"");}
			
			while(foundAction) //Speichere alles bis zum ersten {
			{
				char = file_asc_read(qFile);
				str_for_asc(charStr,char); //Konvertiere das ASC-Zeichen in einen A5-String...
				str_cat(tmpCStr,charStr); //...und fge ihn ans Ende des "tmpCStr" an
				
				if(char == 123) //Klammer gefunden, Werte das Ergebnis aus
				{
//					var i;
					//Entferne alle Zeichen bis der Name der Action anfngt
					i = findASC(tmpCStr,fLetter+fNumber+fUnderline); str_clip(tmpCStr,i);
					//Speichere den Namen in dem aStr-String
					getValue(aStr,tmpCStr,fSpace+fWBracket);
					str_cat(preScanTmp,aStr);
					str_cat(preScanTmp," ");
					//Leere das lChars-Array
					lChars[0] = 0; lChars[1] = 0; lChars[2] = 0; lChars[3] = 0; lChars[4] = 0; lChars[5] = 0; lChars[6] = 0; lChars[7] = 0; lChars[8] = 0; lChars[9] = 0;
					foundAction = 0;
					
					if(writeFile == 0) {sActions += 1;}
				}	
			}
		}
	}
}


///////////////////////////////////////
// Schreibt die gespeicherten Prototypes auf.
function preWrite(tFile)
{	
	file_str_write(tFile,"\n//Automatic defined prototypes\n");
	
	result = 1;
	str_cpy(tmpStr,"");
	while(result) //Schreibe alle Prototypes
	{
		char = str_to_asc(preScanTmp);
		str_clip(preScanTmp,1);
		if(str_len(preScanTmp) <= 1) {result = 0;} //Keine Actionen mehr vorhanden
		
		if(char == space || char == tab || char == enter)
		{
			if(str_len(tmpStr) > 0)
			{
				if(boldKeywords) {file_str_write(tFile,"FUNCTION ");}
					else {file_str_write(tFile,"function ");}
				file_str_write(tFile,tmpStr);
				file_str_write(tFile,"();\n");
			}
			str_cpy(tmpStr,"");
		}
		else
		{
			str_for_asc(charStr,char);
			str_cat(tmpStr,charStr);
		}
	}
	
	//Schreibe Accel in die Datei, falls ntig
	if(foundAccel == 1)
	{
		file_str_write(tFile,"\nfunction accel(&speed,&force,friction)\n");
		file_str_write(tFile,"{\n");
		file_str_write(tFile,"	friction = max((1-time*friction),0);\n");
		file_str_write(tFile,"	speed[0] = friction*speed[0] + time*force[0];\n");
		file_str_write(tFile,"	speed[1] = friction*speed[1] + time*force[1];\n");
		file_str_write(tFile,"	speed[2] = friction*speed[2] + time*force[2];\n");
		file_str_write(tFile,"}\n");
		
		foundAccel = 2; //Zwar gefunden, aber schon definiert
	}
}


///////////////////////////////////////
// Ermittelt anhand von cStat, ob bereits ein Kommentar gefunden wurde und
// beendet dieses an der passenden Stelle. Liefert immer den aktuellen
// Kommentar-Wert zurck.
function checkForComments(cStat)
{
	if(cStat == 0)
	{
		//Ein Kommentar gefunden?
		if(lChars[8] == 47 && char == 47) {return(1);} //Ein "//"-Kommentar gefunden
		if(char == 35)                    {return(1);} //Ein "#"-Kommentar gefunden
		if(lChars[8] == 47 && char == 42) {return(2);} //Ein "/*"-Kommentar gefunden
		if(char == 34)                    {return(3);} //Ein "..."-String gefunden
	}
	else
	{
		//Kommentar zu ende?
		if(cStat == 1 && char == 10) {return(0);} //Ein "//" und "#" Kommentar endet mit ENTER
		if(cStat == 2 && lChars[8] == 42 && char == 47) {return(0);} //Ein "/*"-Kommentar endet mit "*/"
		if(cStat == 3 && char == 34) {return(0);} //Strings enden mit "
	}
	return(cStat); //Noch nicht zurckgeliefert, liefere den Ausgangswert zurck
}


///////////////////////////////////////
// Kopiert den Teil des "qName"-Strings vor dem Punkt und speichert ihn im
// "tStr"-String, mit einer ".c"-Endung
// Verndert: --- tmpStr
function convertQName2TName(tStr,qName)
{
	var i;
	
	i = findASC(qName,fPoint);
	str_cpy(tmpStr,qName);
	str_trunc(tmpStr,str_len(tmpStr)-i); //Schneide alle Zeichen nach dem Punkt ab
	str_cpy(tStr,tmpStr);
	str_cat(tStr,".c.wdl");
//	str_cpy(tStr,qName);
}


///////////////////////////////////////
// Liest solange Zeichen aus der Quell-Datei, bis ein Befehl gefunden wurde.
// Alle Leerzeichen, ect. werden direkt in die Zieldatei geschrieben.
function getNextCommand(qFile,tFile)
{
	var foundCommand;
	var foundComment; //Strings zhlen hier auch als Kommentare
	var foundFunction; //Eine "Funktion", "Aktion" oder "Starter" gefunden?
	var foundSkill;
	var foundIf;
	
	while(foundCommand == 0) //Solange kein Befehl gefunden wurde, schreibe alle Zeichen in die Ziel-Datei, achte auf Kommentare
	{
		lChars[8] = char;
		char = file_asc_read(qFile); //Lies ein Zeichen ein
		
		foundComment = checkForComments(foundComment);
		
		//Schreibe alle Prototypen fr Actionen an den ersten freien Platz
		if(foundComment == 0 && char != 47 && prototypesDone == 0 && writeFile)
		{
			var tChar; tChar = char; //Speichere das momentane Zeichen, wird von "prototypeWrite" berschrieben
			
			preWrite(tFile);
			file_str_write(tFile,"\n"); //Schreibe noch ein Leerzeichen in die Datei
			prototypesDone = 1;
			
			char = tChar; //Restore das alte Zeichen
		}
		
		//Ist das zeichen:
		if(((char >= 48 && char <= 57)      //Eine Zahl...
			|| (char >= 65 && char <= 90)  //...ein Grobuchstabe...
			|| (char >= 97 && char <= 122) //...ein Kleinbuchstabe...
			|| (char == 95))               //...oder der Bodenstrich
			&& foundComment == 0)          //Text steht in keinem Kommentar
				{foundCommand = 1;} //Ein Befehl wurde gefunden
		else //Ein sonstiges Zeichen gefunden
		{
			if(char == -1) {return(-1);} //Ende der Datei erreicht
				else {if(writeFile) {file_asc_write(tFile,char);}} //Schreibe es 1:1 in die Ziel-Datei
		}
	}
	
	if(foundCommand == 1)
	{
		str_cpy(commandStr,""); //Leere den String
		str_for_asc(commandStr,char); //Schreibe das erste Zeichen in den String
		
		lChars[0] = 0; //Leere das lChars-Array
		lChars[1] = 0;
		lChars[2] = 0;
		lChars[3] = 0;
		lChars[4] = 0;
		lChars[5] = 0;
		lChars[6] = 0;
		lChars[7] = 0;
		lChars[8] = 0;
		lChars[9] = char; //Im Char-Buffer befindet sich bereits ein Zeichen
		result = 1;
		while(result/*char != 59 && (lChar != 40 || char != 41)*//*&& char != 123 && char != 125*/) //Keine ';' '{' '}' gefunden
		{
			char = file_asc_read(qFile);
				lChars[0] = lChars[1]; //Speichere die letzten 8 Zeichen
				lChars[1] = lChars[2];
				lChars[2] = lChars[3];
				lChars[3] = lChars[4];
				lChars[4] = lChars[5];
				lChars[5] = lChars[6];
				lChars[6] = lChars[7];
				lChars[7] = lChars[8];
				lChars[8] = lChars[9];
				lChars[9] = char;
			str_for_asc(charStr,char); //Konvertiere das ASC-Zeichen in einen A5-String...
			str_cat(commandStr,charStr); //...und fge ihn ans Ende des "commandStr" an
			
			foundComment = checkForComments(foundComment);

			if(foundComment == 0)
			{
				//berprfe, ob bestimmte Schlsselwrter gefunden wurden
				if((lChars[0] != 95)                           //!"_"
					&& (lChars[1] ==  70 || lChars[1] == 102) //"F" || "f"
					&& (lChars[2] ==  85 || lChars[2] == 117) //"U" || "u"
					&& (lChars[3] ==  78 || lChars[3] == 110) //"N" || "n"
					&& (lChars[4] ==  67 || lChars[4] ==  99) //"C" || "c"
					&& (lChars[5] ==  84 || lChars[5] == 116) //"T" || "t"
					&& (lChars[6] ==  73 || lChars[6] == 105) //"I" || "i"
					&& (lChars[7] ==  79 || lChars[7] == 111) //"O" || "o
					&& (lChars[8] ==  78 || lChars[8] == 110) //"N" || "n"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab))//" "
						{foundFunction = 1;}
				if((lChars[2] != 95)                            //!"_"
					&& (lChars[3] ==  65 || lChars[3] ==  97) //"A" || "a"
					&& (lChars[4] ==  67 || lChars[4] ==  99) //"C" || "c"
					&& (lChars[5] ==  84 || lChars[5] == 116) //"T" || "t"
					&& (lChars[6] ==  73 || lChars[6] == 105) //"I" || "i"
					&& (lChars[7] ==  79 || lChars[7] == 111) //"O" || "o
					&& (lChars[8] ==  78 || lChars[8] == 110) //"N" || "n"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab))//" "
						{foundFunction = 1;}
				if((lChars[1] != 95)                            //!"_"
					&& (lChars[2] ==  83 || lChars[2] == 115) //"S" || "s"
					&& (lChars[3] ==  84 || lChars[3] == 116) //"T" || "t"
					&& (lChars[4] ==  65 || lChars[4] ==  97) //"A" || "a"
					&& (lChars[5] ==  82 || lChars[5] == 114) //"R" || "r"
					&& (lChars[6] ==  84 || lChars[6] == 116) //"T" || "t"
					&& (lChars[7] ==  69 || lChars[7] == 101) //"E" || "e
					&& (lChars[8] ==  82 || lChars[8] == 114) //"R" || "r"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab))//" "
						{foundFunction = 1;}
				if((lChars[3] != 95)                           //!"_"
					&& (lChars[4] ==  83 || lChars[4] == 115) //"S" || "s"
					&& (lChars[5] ==  75 || lChars[5] == 107) //"K" || "k"
					&& (lChars[6] ==  73 || lChars[6] == 105) //"I" || "i"
					&& (lChars[7] ==  76 || lChars[7] == 108) //"L" || "l"
					&& (lChars[8] ==  76 || lChars[8] == 108) //"L" || "l"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab)) //" "
						{foundSkill = 1;}
				if((lChars[6] != 95)                           //!"_"
					&& (lChars[7] ==  73 || lChars[7] == 105) //"I" || "i"
					&& (lChars[8] ==  70 || lChars[8] == 102) //"F" || "f"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab || lChars[9] == 40)) //" " || "("
						{foundIf = 1;}
				if((lChars[4] != 95)                           //!"_"
					&& (lChars[5] ==  69 || lChars[5] == 101) //"E" || "e"
					&& (lChars[6] ==  76 || lChars[6] == 108) //"L" || "l"
					&& (lChars[7] ==  83 || lChars[7] == 115) //"S" || "s"
					&& (lChars[8] ==  69 || lChars[8] == 101) //"E" || "e"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab || lChars[9] == 123)) //" " || "{"
						{foundIf = 1;}
				if((lChars[3] != 95)                           //!"_"
					&& (lChars[4] ==  87 || lChars[4] == 119) //"W" || "w"
					&& (lChars[5] ==  72 || lChars[5] == 104) //"H" || "h"
					&& (lChars[6] ==  73 || lChars[6] == 105) //"I" || "i"
					&& (lChars[7] ==  76 || lChars[7] == 108) //"L" || "l"
					&& (lChars[8] ==  69 || lChars[8] == 101) //"E" || "e"
					&& (lChars[9] == space || lChars[9] == enter || lChars[9] == tab)) //" "
						{foundIf = 2;}

				if(foundSkill == 0 && foundFunction == 0 && (char ==  59 || char == 58)) {result = 0;} //Nur normale Befehle enden auf ein ';'
				if(foundSkill == 1 && char == 125) {result = 0;} //Ein Skill endet hier mit '}'
				if(foundFunction == 1 && char == 123) {result = 0;} //Eine Funktion endet hier mit ihrer ersten '{' Klammer	
				if(foundIf >= 1 && char == 123) {result = 0;} //Eine IF oder ELSE Bedingung endet mit einer '{' Klammer	
			}
		}
	}
}


///////////////////////////////////////
// Liefert den ASC-Wert des Zeichens von "str" an der von "offset" angegebenen
// Stelle. Bei "offset" = 0 wird der Wert des ersten Zeichens zurckgeliefert.
// Tab und Enter werden in Space konvertiert.
// Verndert: --- tmpStr
function getASC(str,offset)
{
	var tChar;
	str_cpy(tmpStr,str);
	str_clip(tmpStr,offset);
	tChar = str_to_asc(tmpStr);
	if(tChar == tab || tChar == enter) {tChar = space;} //Konvertiere TAB oder ENTER in SPACE
	return(tChar);
}


///////////////////////////////////////
// Durchsucht den String nach den von "filter" angegebenen Zeichen, wird eins
// der dieser gefunden, liefert die Funktion das Offset bis zu diesem Zeichen
// zurck.
// Verndert: --- tmpStr
function findASC(str,endMark)
{
	var i;
	str_cpy(tmpStr,str);
	
	while(1)
	{
		char = str_to_asc(tmpStr);
		
		if((char >=  65 && char <=  90) && (endMark&fLetter) == fLetter)       {return(i);} //Grobuchstaben
		if((char >=  97 && char <= 122) && (endMark&fLetter) == fLetter)       {return(i);} //Kleinbuchstaben
		if(((char >=  48 && char <=  57) || char == 46) && (endMark&fNumber) == fNumber) {return(i);} //Zahlen
		if((char ==  space || char == enter || char == tab) && (endMark&fSpace) == fSpace) {return(i);} //Leerzeichen
		if((char ==  komma)             && (endMark&fComma) == fComma)         {return(i);} //Komma
		if((char ==  semikolon)         && (endMark&fSemicolon) == fSemicolon) {return(i);} //Semikolon
		if((char ==  95)                && (endMark&fUnderline) == fUnderline) {return(i);} //Bodenstrich
		if((char >=  40 && char <=  41) && (endMark&fBracket) == fBracket)     {return(i);} //Runde-Klammer
		if((char == 123 || char == 125) && (endMark&fWBracket) == fWBracket)   {return(i);} //Geschweifte-Klammer
		if((char ==  60 || char ==  62) && (endMark&fPBracket) == fPBracket)   {return(i);} //Spitze-Klammer
		if((char ==  46)                && (endMark&fPoint) == fPoint)         {return(i);} //Punkt
		if((char ==  34)                && (endMark&fQuotem) == fQuotem)       {return(i);} //Anfhrungszeichen
		if((char ==  43 || char == 45 || char == 42 || char == 47 || char == 37) && (endMark&fOperater) == fOperater) {return(i);} //Rechenzeichen (+ - * / %)
		
		i += 1;
		str_clip(tmpStr,1);
		
		if(str_len(tmpStr) < 1) {errorMsg(err03); return(9999);} //Den ganzen String durchsucht
	}
}


///////////////////////////////////////
// Diese Funktion liest solange Zeichen aus "str" aus und speichert sie im
// "tStr", bis ein von "endMark" beschriebenes Zeichen erreicht ist. Dabei
// achtet sie auch auf Klammerung, daher gibt der Filter "fBrakets" nur
// geschlssene runde Klammern sinn. Der Quell-String muss allerdings mit einem
// richtigen Zeichen anfangen, da sonst die Ergebnisse nicht stimmen. Liefert
// das zuletzt gefundene Zeichen als ASC-Wert zurck. Allerdings wird Tab und
// Enter in ein Leerzeichen-Wert umgewandelt.
// Verndert: --- tmpStr
function getValue(tStr,str,endMark)
{
	var i;
	var brackets;
	str_cpy(tmpStr,str);
	
	while(1)
	{
		char = str_to_asc(tmpStr);
				
		if(char == 40) {brackets += 1;} //Eine oder nocheine Klammer gefunden
		if(char == 41 && brackets > 0) {brackets -= 1;} //Noch mindestens eine Klammer offen, schliee eine
		if(brackets == 0)
		{
			if(((char >=  65 && char <=  90) && (endMark&fLetter) == fLetter)            //Grobuchstaben
				|| ((char >=  97 && char <= 122) && (endMark&fLetter) == fLetter)       //Kleinbuchstaben
				|| (((char >=  48 && char <=  57) || char == 46) && (endMark&fNumber) == fNumber) //Zahlen + Dezimalpunkt
				|| ((char ==  space || char == enter || char == tab) && (endMark&fSpace) == fSpace) //Leerzeichen
				|| ((char ==  komma)             && (endMark&fComma) == fComma)         //Komma
				|| ((char ==  semikolon)         && (endMark&fSemicolon) == fSemicolon) //Semikolon
				|| ((char ==  95)                && (endMark&fUnderline) == fUnderline) //Bodenstrich
				|| ((char >=  40 && char <=  41) && (endMark&fBracket) == fBracket)     //Runde-Klammer
				|| ((char == 123 || char == 125) && (endMark&fWBracket) == fWBracket)   //Geschweifte-Klammer
				|| ((char ==  60 || char ==  62) && (endMark&fPBracket) == fPBracket)   //Spitze-Klammer
				|| ((char ==  46)                && (endMark&fPoint) == fPoint)         //Punkt
				|| ((char ==  34)                && (endMark&fQuotem) == fQuotem)      //Anfhrungszeichen
				|| ((char ==  43 || char == 45 || char == 42 || char == 47 || char == 37) && (endMark&fOperater) == fOperater)) //Rechenzeichen (+ - * / %)
					{
						str_cpy(tStr,str);
						str_trunc(tStr,str_len(str)-i); //Schneide alle nicht-berprften Zeichen ab
						if(char == tab || char == enter) {char = space;} //Wandle TAB und ENTER in SPACE um
						return(char);
					}
		}
				
		i += 1;
		str_clip(tmpStr,1); //Gehe zum nchsten Zeichen
		
		if(str_len(tmpStr) < 1) {errorMsg(err04); return(9999);} //Den ganzen String durchsucht
	}
	
}


///////////////////////////////////////
// Diese Funktion berprft, ob sich im "commandStr" ein alter Befehl befindet
// und updatet diesen falls ntig. Liefert zurck ob eine Datei geffnet werden
// soll (1) oder nicht (0).
function checkCommand()
{
	if(str_cmpni(commandStr,"include") == 1 && getASC(commandStr,7) == space) {includeFILE(); return(1);} //Return(1) == ffne include
	//Die Befehle, die upgedatet werden mssen
	if(str_cmpni(commandStr,"accel") == 1 && getASC(commandStr,5) == space) {updateACCEL(); return(0);} //Das Zeichen nach ACCEL muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"set") == 1   && getASC(commandStr,3) == space) {updateSET(); return(0);} //Das Zeichen nach SET muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"skill") == 1 && getASC(commandStr,5) == space) {updateSKILL(); return(0);} //Das Zeichen nach SKILL muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"call") == 1  && getASC(commandStr,4) == space) {updateCALL(); return(0);} //Das Zeichen nach CALL muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"wait") == 1  && getASC(commandStr,4) == space) {updateWAIT(); return(0);} //Das Zeichen nach WAIT muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"waitt") == 1 && getASC(commandStr,5) == space) {updateWAITT(); return(0);} //Das Zeichen nach WAITT muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"to_angle") == 1 && (getASC(commandStr,8) == space || getASC(commandStr,8) == komma)) {updateTOANGLE(); return(0);} //Das Zeichen nach TO_ANGLE muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"vecrotate") == 1 && getASC(commandStr,9) == space) {updateVECROTATE(); return(0);} //Das Zeichen nach VECROTATE muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"normalize") == 1 && getASC(commandStr,9) == space) {updateNORMALIZE(); return(0);} //Das Zeichen nach NORMALIZE muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"to_skill") == 1 && getASC(commandStr,8) == space) {updateTOSKILL(); return(0);} //Das Zeichen nach TO_SKILL muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"to_string") == 1 && getASC(commandStr,9) == space) {updateTOSTRING(); return(0);} //Das Zeichen nach TO_STRING muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"set_string") == 1 && getASC(commandStr,10) == space) {updateSETSTRING(); return(0);} //Das Zeichen nach SET_STRING muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"add_string") == 1 && getASC(commandStr,10) == space) {updateADDSTRING(); return(0);} //Das Zeichen nach ADD_STRING muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"stricmp") == 1 && getASC(commandStr,7) == space) {updateSTRICMP(); return(0);} //Das Zeichen nach STRICMP muss ein Leerzeichen sein
	if(str_cmpni(commandStr,"end") == 1   && (getASC(commandStr,3) == space || getASC(commandStr,3) == semikolon)) {updateEND(); return(0);} //Das Zeichen nach END muss ein Leerzeichen sein
	
	str_cpy(fixedCommandStr,commandStr);
}


///////////////////////////////////////
// ffnet eine inlcude-Datei und datet diese auch ab.
function includeFILE()
{
	if(writeFile == 0) {sIncludedFiles += 1;}

	var i;
	var includeType; //1 = include<...>; 2 = include"...";
	str_cpy(aStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,7); //Schneide das "include" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	if(getValue(aStr,tmpCStr,fPBracket+fQuotem) == 34) {includeType = 2;} else {includeType = 1;} //Include wird mit " oder > beendet?
	str_clip(tmpCStr,str_len(aStr));
	
	str_cpy(qStr,aStr);
	convertQName2TName(tStr,qStr);

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"INCLUDE ");}
		else {str_cpy(fixedCommandStr,"include ");}
	if(includeType == 1) {str_cat(fixedCommandStr,"<");}
	if(includeType == 2) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,tStr);
	if(includeType == 1) {str_cat(fixedCommandStr,">");}
	if(includeType == 2) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,";");
}

///////////////////////////////////////
// Diese Funktion wandelt ACCEL in den neuen Syntax um.
function updateACCEL()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	str_cpy(cStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,5); //Schneide das "accel" ab
		
	//Entferne Zeichen bis der erste Wert anfngt
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne Zeichen bis der zweite Wert anfngt
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den zweiten Wert in dem bStr-String
	getValue(bStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(bStr));

	//Entferne Zeichen bis der dritte Wert anfngt
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den dritten Wert in dem cStr-String
	getValue(cStr,tmpCStr,fSpace+fSemicolon); str_clip(tmpCStr,str_len(cStr));
	
	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"ACCEL(");}
		else {str_cpy(fixedCommandStr,"accel(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	str_cat(fixedCommandStr,bStr);
	str_cat(fixedCommandStr,",");
	str_cat(fixedCommandStr,cStr);
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt SET in den neuen Syntax um.
function updateSET()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,3); //Schneide das "set" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater+fBracket);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma+fSemicolon);
	str_clip(tmpCStr,str_len(aStr));
	
	//Suche nach dem Wert fr b
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater+fBracket);
	str_clip(tmpCStr,i);
	
	//Speichere den zweiten Wert in dem bStr-String
	getValue(bStr,tmpCStr,fSemicolon);
	str_clip(tmpCStr,str_len(bStr));
	
	//Erstelle den neuen Syntax
	str_cpy(fixedCommandStr,"");
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr," = ");
	str_cat(fixedCommandStr,bStr);
	str_cat(fixedCommandStr,";");
}


///////////////////////////////////////
// Diese Funktion wandelt SKILL in den neuen Syntax um.
function updateSKILL()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	var values;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	str_cpy(cStr,"");
	str_cpy(dStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,5); //Schneide das "skill" ab
	
	//Entferne alle Zeichen bis der Name des Skills anfngt
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline); str_clip(tmpCStr,i);
	//Speichere den Namen in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fWBracket);
	if(getASC(tmpCStr,str_len(aStr)) == space) {i = findASC(tmpCStr,fWBracket);} else {i = str_len(aStr);}
	str_clip(tmpCStr,i+1); //Schneide bis inklusive der {-Klammer alle Zeichen ab
	
	if(getValue(bStr,tmpCStr,fSemicolon+fWBracket) == semikolon) //Wenn ein Semikolon gefunden wird, hat der Skill mindestens einen Wert
	{
		values = 1;
		
		//Entferne Zeichen bis zur {-Klammer
//		i = findASC(tmpCStr,fWBracket); str_clip(tmpCStr,i);
		//Entferne Zeichen bis "VAL" anfngt
		i = findASC(tmpCStr,fLetter); str_clip(tmpCStr,i);
		//Schneide "VAL" oder sonstigen Bezeichner ab
		i = findASC(tmpCStr,fSpace); str_clip(tmpCStr,i);
		//Entferne Zeichen bis der erste Wert anfngt
		i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
		//Speichere den ersten Wert in dem bStr-String
		if(getValue(bStr,tmpCStr,fSpace+fSemicolon) == space) {i = findASC(tmpCStr,fSemicolon);} else {i = str_len(bStr);}
		str_clip(tmpCStr,i+1); //Schneide alles nach dem ersten Wert bis inklusive das Semikolon ab
		
		//berprfe ob das nchste Trennzeichen ein ";" oder ein "}" ist, ersteres ist bedeutet noch ein Wert
		if(getValue(cStr,tmpCStr,fSemicolon+fWBracket) == semikolon) //Ein weiteres ";" gefunden
		{
			values = 2;
			
			//Entferne Zeichen bis "VAL" anfngt
			i = findASC(tmpCStr,fLetter); str_clip(tmpCStr,i);
			//Schneide "VAL" oder sonstigen Bezeichner ab
			i = findASC(tmpCStr,fSpace); str_clip(tmpCStr,i);
			//Entferne Zeichen bis der erste Wert anfngt
			i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
			//Speichere den zweiten Wert in dem cStr-String
			if(getValue(cStr,tmpCStr,fSpace+fSemicolon) == space) {i = findASC(tmpCStr,fSemicolon);} else {i = str_len(cStr);}
//			if(getASC(tmpCStr,str_len(cStr)) == space) {i = findASC(tmpCStr,fSemicolon);} else {i = str_len(cStr);}
			str_clip(tmpCStr,i+1); //Schneide alles nach dem ersten Wert bis inklusive das Semikolon ab
			
			if(getValue(dStr,tmpCStr,fSemicolon+fWBracket) == semikolon) //Noch ein ";" gefunden
			{
				values = 3;
				//Entferne Zeichen bis "VAL" anfngt
				i = findASC(tmpCStr,fLetter); str_clip(tmpCStr,i);
				//Schneide "VAL" oder sonstigen Bezeichner ab
				i = findASC(tmpCStr,fSpace); str_clip(tmpCStr,i);
				//Entferne Zeichen bis der erste Wert anfngt
				i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
				//Speichere den dritten Wert in dem dStr-String
				getValue(dStr,tmpCStr,fSpace+fSemicolon);
			}
		}
	}
	
	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"VAR ");}
		else {str_cpy(fixedCommandStr,"var ");}
	str_cat(fixedCommandStr,aStr);
	if(values == 2) {str_cat(fixedCommandStr,"[2]");}
	if(values == 3) {str_cat(fixedCommandStr,"[3]");}
	if(values > 0)
	{
		str_cat(fixedCommandStr," = ");
		str_cat(fixedCommandStr,bStr);
		if(values > 1) {
			str_cat(fixedCommandStr,",");
			str_cat(fixedCommandStr,cStr);
			if(values > 2) {
				str_cat(fixedCommandStr,",");
				str_cat(fixedCommandStr,dStr);
			}
		}
	}
	/*if(values != 0) {*/str_cat(fixedCommandStr,";");//} //Schreibe kein ; ans Ende, wenn der Skill keine Werte hatte, da sich noch ein ; im Buffer nach dem Skill befindet
}


///////////////////////////////////////
// Diese Funktion wandelt CALL in den neuen Syntax um.
function updateCALL()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,4); //Schneide das "call" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fSemicolon);
	str_clip(tmpCStr,str_len(aStr));
	
	//Erstelle den neuen Syntax
	str_cpy(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,"();");
}


///////////////////////////////////////
// Diese Funktion wandelt WAIT in den neuen Syntax um.
function updateWAIT()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,4); //Schneide das "wait" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fSemicolon+fBracket);
	str_clip(tmpCStr,str_len(aStr));
	
	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"WAIT(");}
		else {str_cpy(fixedCommandStr,"wait(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt WAITT in den neuen Syntax um.
function updateWAITT()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,5); //Schneide das "waitt" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fSemicolon+fBracket);
	str_clip(tmpCStr,str_len(aStr));
	
	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"WAITT(");}
		else {str_cpy(fixedCommandStr,"waitt(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt TO_ANGLE in den neuen Syntax um.
function updateTOANGLE()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,8); //Schneide das "to_angle" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma);
	str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater);
	str_clip(tmpCStr,i);
	
	//Speichere den ersten Wert in dem aStr-String
	getValue(bStr,tmpCStr,fSpace+fSemicolon);
	str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"RESULT = VEC_TO_ANGLE( ");}
		else {str_cpy(fixedCommandStr,"result = vec_to_angle(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	str_cat(fixedCommandStr,bStr);
	str_cat(fixedCommandStr,"); ");
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,"[2] = result;");	
}


///////////////////////////////////////
// Diese Funktion wandelt VECROTATE in den neuen Syntax um.
function updateVECROTATE()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,9); //Schneide das "vecrotate" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(bStr,tmpCStr,fSpace+fSemicolon); str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"VEC_ROTATE(");}
		else {str_cpy(fixedCommandStr,"vec_rotate(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	str_cat(fixedCommandStr,bStr);
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt NORMALIZE in den neuen Syntax um.
function updateNORMALIZE()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,9); //Schneide das "normalize" ab
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(bStr,tmpCStr,fSpace+fSemicolon); str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"VEC_NORMALIZE(");}
		else {str_cpy(fixedCommandStr,"vec_normalize(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	str_cat(fixedCommandStr,bStr);
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt TO_SKILL in den neuen Syntax um.
function updateTOSKILL()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	var dString; //Direkt angegebener String
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,8); //Schneide das "to_skill" ab

	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline/*+fQuotem*/+fOperater); str_clip(tmpCStr,i);
	//Speichere den zweiten Wert in dem bStr-String
	if(getValue(bStr,tmpCStr,fSemicolon+fQuotem) != semikolon) {dString = 1;} str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	str_cpy(fixedCommandStr,aStr);
	if(boldKeywords) {str_cat(fixedCommandStr," = STR_TO_NUM(");}
		else {str_cat(fixedCommandStr," = str_to_num(");}
	if(dString) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,bStr);
	if(dString) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt TO_STRING in den neuen Syntax um.
function updateTOSTRING()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,9); //Schneide das "to_string" ab

	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline/*+fQuotem*/+fOperater); str_clip(tmpCStr,i);
	//Speichere den zweiten Wert in dem bStr-String
	getValue(bStr,tmpCStr,fSpace+fSemicolon); str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"STR_FOR_NUM(");}
		else {str_cpy(fixedCommandStr,"str_for_num(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	str_cat(fixedCommandStr,bStr);
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt SET_STRING in den neuen Syntax um.
function updateSETSTRING()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	var dString; //Direkt angegebener String
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,10); //Schneide das "set_string" ab

	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline/*+fQuotem*/+fOperater); str_clip(tmpCStr,i);
	//Speichere den zweiten Wert in dem bStr-String
	if(getValue(bStr,tmpCStr,fSemicolon+fQuotem) != semikolon) {dString = 1;} str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"STR_CPY(");}
		else {str_cpy(fixedCommandStr,"str_cpy(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	if(dString) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,bStr);
	if(dString) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt ADD_STRING in den neuen Syntax um.
function updateADDSTRING()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	var dString; //Direkt angegebener String
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,10); //Schneide das "add_string" ab

	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	getValue(aStr,tmpCStr,fSpace+fComma); str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline/*+fQuotem*/+fOperater); str_clip(tmpCStr,i);
	//Speichere den zweiten Wert in dem bStr-String
	if(getValue(bStr,tmpCStr,fSemicolon+fQuotem) != semikolon) {dString = 1;} str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"STR_CAT(");}
		else {str_cpy(fixedCommandStr,"str_cat(");}
	str_cat(fixedCommandStr,aStr);
	str_cat(fixedCommandStr,",");
	if(dString) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,bStr);
	if(dString) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt STRICMP in den neuen Syntax um.
function updateSTRICMP()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	var i;
	var dString1; //String1 ist ein direkt angegebener String
	var dString2; //String2 ist ein direkt angegebener String
	str_cpy(aStr,"");
	str_cpy(bStr,"");
	
	str_cpy(tmpCStr,commandStr); //Mache eine Kopie des "commandStr"
	str_clip(tmpCStr,7); //Schneide das "stricmp" ab

	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den ersten Wert in dem aStr-String
	if(getValue(aStr,tmpCStr,fComma+fQuotem) != komma) {dString1 = 1;} str_clip(tmpCStr,str_len(aStr));
	
	//Entferne unbrauchbaren Zeichen vom String-Anfang
	i = findASC(tmpCStr,fLetter+fNumber+fUnderline+fOperater); str_clip(tmpCStr,i);
	//Speichere den zweiten Wert in dem bStr-String
	if(getValue(bStr,tmpCStr,fSemicolon+fQuotem) != semikolon) {dString2 = 1;} str_clip(tmpCStr,str_len(bStr));

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"RESULT = STR_CMPI(");}
		else {str_cpy(fixedCommandStr,"result = str_cmpi(");}
	if(dString1) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,aStr);
	if(dString1) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,",");
	if(dString2) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,bStr);
	if(dString2) {str_cat(fixedCommandStr,"\"");}
	str_cat(fixedCommandStr,");");
}


///////////////////////////////////////
// Diese Funktion wandelt END in den neuen Syntax um.
function updateEND()
{
	if(writeFile == 0) {sOldCommands += 1; return;}

	//Erstelle den neuen Syntax
	if(boldKeywords) {str_cpy(fixedCommandStr,"RETURN;");}
		else {str_cpy(fixedCommandStr,"return;");}	
}