///////////////////////////////////////////////////////////////////////////////////
// RPG_Test Main Code
////////////////////////////////////////////////////////////////////////////

path "D:\\Program Files\\GStudio\\template";	

include <entstrings.wdl>;
include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;		
include <particle.wdl>; 
include <doors.wdl>;		
include <actors.wdl>;   
include <weapons.wdl>;  
include <war.wdl>;      
include <lflare.wdl>;   

var video_mode = 7;
var video_depth = 32; 
var d3d_alphadepth = 32;
var d3d_shadowdepth = 32;

string level_str = <test.WMB>; 


bmap splashmap = <logodark.pcx>; 
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}

bmap panel_main = <panels.bmp>;

panel panelmain
{
pos_x 1;pos_y 1;layer 50;bmap panel_main;FLAGS OVERLAY;
}


sky horizon_sky {
	type = <horizon.pcx>;
	tilt = -10;
	flags = scene,overlay,visible;
	layer = 3;
}

function main()
{

camera.ambient = 18;

var video_depth = 32; 
var d3d_alphadepth = 32;
var d3d_shadowdepth = 32;

fog_color = 1;
camera.fog = 29;

fog_color = 2;
camera.fog = 29;


fog_color = 3;
camera.fog = 29;

fog_color = 4;
camera.fog = 37;

tex_share = on;	
splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
splashscreen.visible = on;

wait(3);
level_load(level_str);
freeze_mode = 1;
sleep(1);
splashscreen.visible = off;
bmap_purge(splashmap);	y
load_status();
ifdef CAPS_FLARE;
lensflare_start();
endif;
freeze_mode = 0;
bg_color = 5;
person_3rd = 2;
mouse_toggle();
}


///////**


var my_target[3];
var move_position[3];

Function change_run() 
{
	if(player.skill10 == 0) 
	{player.skill10 = 1;}   
	else //if run mode is already turned on
	{
	player.skill10 = 0; 
	}
}

Function get_target() 
{
mouse_to_level();
vec_set(my_target,target); 
vec_set(move_position,target); 
vec_sub(move_position,player.x); 
vec_to_angle(player.pan,move_position); 
player.tilt = 0; 
if(key_shift == 1) 
{
player.skill48 = 0; 
weapon_fire(); 
return; 
	}
player.skill48 = 1; 
}

Function my_move() 
{
while(1) // always run this code
{
   		 if(player.skill48 == 1) 
   		 {
     			  while(vec_dist(player.x,my_target.x) > 35) 
     			 {
       			if(player.skill10 == 1) 
       			{
				force = my._force * 9; 
				//so we will multiply _force by 2.5 and assign that to force
				}
       			else //if the player is not in run mode
       			{
				force = my._force * 6; 
				}
			if(mouse_right == 1){wait(1);player.skill48 = 0;break;}
			move_gravity();
			wait(1); 
			}
		}
wait(1); /
}
}


Action player_1 //player action
{
player_walk_fight(); 
my_move(); 
}


	On_r  change_run; //when the R key is pressed it will run the above function and toggle the run mode
	On_mouse_left  get_target; //when the left mouse button is clicked call the get_target function
	


	


ACTION fence
{
my.oriented = on;
}

/////////////////////////////////*****
//////-----------
bmap rauch_map,<smoke2.bmp>;

// ************* GLOBAL VARIABLES ***************

var parray [1801]; // will be used as a 300*6 multi dimensional array
                   // each of the 300 entries will consist of: 0 = flag, 1 = x_pos, 2-5 = data slots
var ppoint = 0;    // points to the next free entry-slot, is set through searcharray()

var boom = 0; 	   // counter for explosion effects

// ************** SKILL USAGE ****************
// skill 7        size
// skill 8        rate / duration
// skill 10-12    pos
// skill 13       counter
// skill 14       points to the emitters array offset in parray[]

// *************** ARRAY FUNCTION **************

function sarray() {
	ppoint = 0;
	while (parray [ppoint*6] != 0) { ppoint += 1; }
}

// ************** SMOKE ****************

action C_Smoke
{
my.passable = on;
my.invisible = on;
	sarray();	 						// look for free array slot
	if (ppoint >= 300) {  }					// stop action if too many emitters already present
	my.skill14 = ppoint;						// set skill14 accordingly
	parray[my.skill14 * 6] = 1;					// set flag of the slot to occupied
	if (my.skill8 == 0) { my.skill8 = 4; }				// rate 0 defaults to 4
	if (my.skill7 == 0) { my.skill7 = 1; }				// size 0 defaults to 1
	if (my.skill7 < 0.2 && my.skill7 != -1) { my.skill7 = 0.2; }	// check size values and correct them
	if (my.skill7 > 3) { my.skill7 = 3; }
	while(1) {							// smokes forever
		if (my.skill7 > 0) {					// check if effect is turned ON
			my.skill13 -= 1;				// decrease emit counter
			if (my.skill13 <= 0) {
				my.skill13 = my.skill8 / time;					// set counter according to skill8

				parray[my.skill14 * 6 +2] = my.skill7;				// set size value in array
				parray[my.skill14 * 6 +1] = my.x + (random(4) - 2) * my.skill7;	// set pos.x value in array
				my.skill10 = my.skill14;					// array pointer stored in x_pos
				my.skill11 = my.y + (random(4) - 2) * my.skill7;		// set pos.y for emit
				my.skill12 = my.z;						// set pos.z for emit
				emit(1,my.skill10,smoke_particle);				// emit particle
    my.transparent = on; // Transparent Flare
			}
		}
		wait(1);
	}
}

function smoke_particle(){
	if(my_age == 0)	{
		my_alpha = 70;						// set to invisible at start
		my_color.blue = parray[my_pos.x * 6 + 1];		// get size from array
		my_speed.z = (0.7+random(1)) * my_color.blue;		// set speed.z
		my_color.red = random (80);				// set random values
		my_color.green = random (50);
		my_size = (50+random(100)) * my_color.blue;		// set size
		my_map = rauch_map;
		my_flare = on;						// set transparency
		
	}
 	if (my_age > 80) {			// kill if too old
			MY_ACTION = null;
	}
	if (my_age > 17) {						// set alpha according to age
		my_alpha = 40 - my_age/2;
	} else { my_alpha = my_age * 2; }
	my_speed.x = (sin(my_age * 6 + my_color.red) / 2.5) * my_color.blue;	// movement
	my_speed.y = (cos(my_age * 7 + my_color.green) / 2) * my_color.blue;
}

///////////////////////////////////////**

bmap fire_parmap=<fireball.tga>;

function fire_effect();
function fire_property();


function fire_effect() {
	my.x+=random (15*(sin(total_ticks*200) * cos(total_ticks*50)));

	my.y+=random (15*(sin(total_ticks*200) * sin(total_ticks*50)));

	my.size=15;
	my.vel_x=0;
	my.vel_y=0;
	my.vel_z=2+random(2);
	my.move=on;
	my.bmap=fire_parmap;
	my.flare=on;
	my.bright=on;
	my.alpha=25;
	my.function=fire_property;
}

function fire_property() {
	my.alpha-=1*time;
	if (my.alpha<=0) {
		my.lifespan=0;
	}
}

action fire {
	While (1) {
		temp.x=my.x;
		temp.y=my.y;
		temp.z=my.z;
		effect(fire_effect,10*time,temp,temp);
		Wait(1);
	}
}

////////////////////////////////****

Action rock //test rock
{
my.passable = off;
}