/////////////////////////////////////////////////////////////////////////
// copy the files from this folder inside your \work folder
// don't forget to include entstrings.wdl BEFORE the wdl files 
// that are used for the entities with names above their heads
// place a line that looks like this:
//        name_ent1();
// as the first line in the action attached to the first entity, and
//        name_ent2();
// as the first line in the action attached to the second entity
/////////////////////////////////////////////////////////////////////////

font system_font = <system.pcx>, 10, 12; 

/////////////////////////////////////////////////////////////////////////

text name1_txt
{
	font = system_font;
	string = "Johanna";
}

text name2_txt 
{
	font = system_font;
	string = "This is a rock";
}

/////////////////////////////////////////////////////////////////////////

function name_ent1()
{
	while (1)
	{
		vec_set (temp, my.x);
		temp.z += 40; // play with this value for every entity
		trace_mode = ignore_me + ignore_models + ignore_passents;
		if (trace (my.x, camera.x) == 0) // if the entity is visible on the screen 
		{
			vec_to_screen (temp, camera);
			name1_txt.pos_x = temp.x; // set the position of the text
			name1_txt.pos_y = temp.y; // on x and y 
			name1_txt.visible = on; // and make it visible
		}
		else // the entity isn't visible on the screen?
		{
			name1_txt.visible = off; // hide the text
		}
		wait (1);
	}		
}

function name_ent2()
{
	while (1)
	{
		vec_set (temp, my.x);
		temp.z += 60; // play with this value for every entity
		trace_mode = ignore_me + ignore_models + ignore_passents;
		if (trace (my.x, camera.x) == 0) // if the entity is visible on the screen 
		{
			vec_to_screen (temp, camera);
			name2_txt.pos_x = temp.x; // set the position of the text
			name2_txt.pos_y = temp.y; // on x and y 
			name2_txt.visible = on; // and make it visible
		}
		else // the entity isn't visible on the screen?
		{
			name2_txt.visible = off; // hide the text
		}
		wait (1);
	}		
}
